/*********************************************************************
 *	WIN32: RS232C ̐.
 *********************************************************************

 * EI:
int		RS_init(char *portno,int baudrate);
void	RS_exit(void);

 * 菇[̎s:
void	RS_terminal(char *port_no,int baudrate);

 * f[^M:
int		RS_putdata(	unsigned char *buf , int cnt );
int		RS_putc(int c);
 * f[^M:
int		RS_checkdata();
int		RS_getdata(unsigned char *buf,int cnt);

 * L[{[h:
int		RS_keyInput(void);

void	memdump(void *ptr,int len,int off);
int		UsbInit(int verbose,int enable_bulk);	
int		UsbExit(void);
void 	UsbBench(int cnt,int psize);
void	UsbDump(int adr,int arena,int size);
void 	UsbPoke(int adr,int arena,int data0,int data1);
int 	UsbPeek(int adr,int arena);
int 	UsbRead(int adr,int arena,uchar *buf,int size);
void 	UsbBench2(int cnt,int psize);
void 	UsbSetBaudRate(int ubrr,int bits);
 *
 *********************************************************************
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <signal.h>
#include <usb.h>
#include <time.h>


#include "w32term.h"
#include "rs232c.h"
#include "util.h"
/*********************************************************************
 *	`
 *********************************************************************
 */
#define	    COM_DEVICENAME  "\\\\.\\COM%s"	
//  "\\.\"tȂꍇ COM|[g1`9܂łΉłȂ.
//				tꍇ1`99܂.

#define		KEY_ESCAPE_CH	0x01

#define	MAX_RESULT_LENGTH	32		//Mobt@.

#define	RESULT_LENGTH_MASK	0x7f	//M̗L}XNrbg.
#define	TXBUF_FULL_MASK		0x80	//Mobt@trbg.

#define	RS_EMPTY			(-9)

//#define	BENCH_LENGTH		80		//x`}[N: PsM̒.
#define	BENCH_LENGTH		450		//x`}[N: PsM̒.
#define	BENCH_COUNT			250		//x`}[N: PsM̉.
/*********************************************************************
 *	O[o
 *********************************************************************
 */
static char	COM_Device[256];
HANDLE		thread;
DWORD		thid;
HANDLE		comHandle;
OVERLAPPED	ovlrd;
OVERLAPPED	ovlwr;
HANDLE		ovlrd_hEvent;
HANDLE		ovlwr_hEvent;

void	Term_Log(int c);
usb_dev_handle *usb_dev; /* the device handle */
extern char *upfile;	//Abv[ht@C.
FILE *upload_fp=NULL;
int		opt_d;


void	memdump(void *ptr,int len,int off);
/*********************************************************************
 *	qrQRQb f[^ o.
 *********************************************************************
 */
int	RS_putdata(	unsigned char *buf , int cnt )
{
	DWORD dwWritten=0;
	DWORD wcnt = 0;

	memset(&ovlwr,0,sizeof(OVERLAPPED));
	ovlwr.hEvent = ovlwr_hEvent;

//	buf[cnt]=0; printf("%02x\n",buf[0]);

	int rc = WriteFile(comHandle, buf , cnt , &dwWritten, &ovlwr);
	if (rc == 0) {
		if((rc = GetLastError() ) == ERROR_IO_PENDING) 
		{
//			WaitForSingleObject(ovlwr.hEvent, INFINITE);
			GetOverlappedResult(comHandle,&ovlwr,&wcnt,FALSE);
			//printf("putComPort() data = %x\n",buf[0]);
			return cnt;
		}
	}
	return cnt;
}

/*********************************************************************
 *	qrQRQbo.
 *********************************************************************
 */
int	RS_putc(int c)
{
	u_char buf[16];
	buf[0]=c;
	RS_putdata(buf,1);
	return 0;
}
int	RS_puts(u_char *buf,int len)
{
	RS_putdata(buf,len);
	return 0;
}
/*********************************************************************
 *	R\[
 *********************************************************************
 */
int	RS_keyInput(void)
{
	if(kbhit())	{
		return getch();
	}
	return 0;
}
/*********************************************************************
 *	t@CAbv[h@\܂ރR\[
 *********************************************************************
 */
int	RS_keyInputUP(void)
{
	if(upload_fp) {	//Abv[h.
		int c = fgetc(upload_fp);	//t@C當擾.
		if(c != EOF) {
			return c;
		}
		fclose(upload_fp);
		upload_fp = NULL;
	}
	return RS_keyInput();
}
/*********************************************************************
 *	COMMfoCXPoCgM.
 *********************************************************************
 *	߂l:
 *		0 MȂ.
 *		1 Mnj.
 *
 *
 */
int	RS_getdata(unsigned char *buf,int cnt)
{
	DWORD	r=0;
	DWORD	rcnt = 0;

	memset(&ovlrd,0,sizeof(OVERLAPPED));
	ovlrd.hEvent = ovlrd_hEvent;

	int	rc = ReadFile( comHandle, buf , cnt , &r , &ovlrd ); 
	if (rc) {
		if(r == cnt) {
		// ǂݍݐ.
			return cnt;	//M.
		}
		//printf("RxError1 rc = %d\n",rc);
		return 0;
	}else{

		// xǂݍݒEEE.
		if(( rc =GetLastError() ) == ERROR_IO_PENDING) {
			WaitForSingleObject(ovlrd.hEvent, INFINITE);
			rc = GetOverlappedResult(comHandle,&ovlrd,&rcnt,FALSE);
			if(rc) {
				if(rcnt == cnt) 
				{
					return cnt;	// Mnj.
				}
			}
			//printf("RxError3 rc = %d\n",rc);
			return 0;
		}
		//printf("RxError4 rc = %d\n",rc);
		return 0;
	}
	return 0;
}
/*********************************************************************
 *	
 *********************************************************************
 */
int	RS_checkdata()
{
	DWORD DErr=0;
	COMSTAT commstat;

	ClearCommError(comHandle,&DErr,&commstat);
	return commstat.cbInQue ;

}

/*********************************************************************
 *	
 *********************************************************************
 */
int	RS_getc()
{
	int c;
	unsigned char buf[16];

	if(	RS_checkdata() ) {
		RS_getdata(buf,1);
		c = buf[0];
		return c & 0xff;
	}
	
	return RS_EMPTY;	// Empty
}

/*********************************************************************
 *	bnl|[g̏
 *********************************************************************
 */
int	RS_init(char *portno,int baudrate)
{
	static	DCB	com_dcb;
	DWORD 		DErr;

	sprintf(COM_Device,COM_DEVICENAME,portno);
	comHandle =	CreateFile(
		COM_Device,									/* VA|[g̕ */
		GENERIC_READ | GENERIC_WRITE   ,			/* ANZX[h */
		0,
		NULL,										/* ZLeB */
		OPEN_EXISTING,								/* 쐬tO	*/
//		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED, /*  */
		0,											/*  */
		NULL										/* ev[g̃nh	*/
	);

	if(comHandle ==	INVALID_HANDLE_VALUE) {
		fprintf(stderr,	"Can't Open COM Port (%s:).\n",COM_Device + strlen("\\\\.\\") );
		exit(1);
	}

	ovlrd_hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	ovlwr_hEvent = CreateEvent(NULL,TRUE,TRUE ,NULL);

	{
		ClearCommError(comHandle,&DErr,NULL);
		SetupComm(comHandle,8192,2048);
		PurgeComm(comHandle,PURGE_TXABORT | PURGE_RXABORT |PURGE_TXCLEAR |	PURGE_RXCLEAR);

		memset(&com_dcb,0,sizeof(com_dcb));
		com_dcb.DCBlength = sizeof(DCB);
		GetCommState(comHandle,&com_dcb);

		com_dcb.BaudRate = baudrate;
		com_dcb.ByteSize = 8;
		com_dcb.Parity   = NOPARITY;
		com_dcb.StopBits = ONESTOPBIT;
		SetCommState(comHandle,&com_dcb);

		SetCommMask(comHandle,0);
		SetCommMask(comHandle,EV_RXCHAR);

		EscapeCommFunction(comHandle, CLRBREAK);
		EscapeCommFunction(comHandle, SETDTR);
		EscapeCommFunction(comHandle, SETRTS);
	}
	return 0;
}

/*********************************************************************
 *
 *********************************************************************
 */

void RS_exit(void)
{
	CloseHandle(ovlwr_hEvent);
	CloseHandle(ovlrd_hEvent);
	CloseHandle(comHandle);
}
/*********************************************************************
 *	GR[obNET[o[.
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_echohost(char *port_no,int baudrate)
{
	int c;
	unsigned char buf[16];
	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering EchobackMode: Escape=^%c\n", '@' +	KEY_ESCAPE_CH );

	while(1) {
		c = RS_keyInput();if(c == KEY_ESCAPE_CH) break;	//Eo.
		if(	RS_checkdata() ) {
			RS_getdata(buf,1);
			c = buf[0];
			RS_putc(c);
			putchar(c);
			if(c == '\r') {
				c = '\n';
				RS_putc(c);
				putchar(c);
			}
		}
	}
	RS_exit();
}

void bench_tx()
{
	int i,c=' ';
	
#if	0
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		RS_putc(c);
	}
#else
	u_char buf[BENCH_LENGTH+16];
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		buf[i]=c;
	}
	RS_puts(buf,BENCH_LENGTH);
//	printf("Send data=\n");
//	memdump(buf,BENCH_LENGTH,0);
#endif
}

int bench_rx(void)
{
	int i,c=' ',r,errs=0;
	u_char buf[BENCH_LENGTH+1024];
	memset(buf,0,BENCH_LENGTH+1024);
	
	for(i=0;i<BENCH_LENGTH;i++,c++) {
		do {
			r = RS_getc();
		}while (r == RS_EMPTY);

		buf[i]=r;
		//memdump(buf+i,1,0);
		if(opt_d) {
			printf(" %02x",r);
		}

		if(r != (c & 0xff) ) {
			errs++;
		}
	}
	if(errs) {
		printf("Recv Error = %2d:\n", errs);
		memdump(buf,BENCH_LENGTH,0);
	}

	if(opt_d) {
		printf("\n");
	}

	return errs;
}

/*********************************************************************
 *	
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_benchmark(char *port_no,int baudrate)
{
	int c,i;
	int count=BENCH_COUNT;
	int time1, rate;
	int total;

	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering Benchmark: Escape=^%c\n", '@' + KEY_ESCAPE_CH );
	int time0 = clock();

	bench_tx();
	for(i=0;i<count;i++) {
		bench_tx();
		c = RS_keyInput();if(c == KEY_ESCAPE_CH) break;	//Eo.
		bench_rx();
		putchar('.');
		fflush(stdout);
	}
	bench_rx();
	
	printf("\nBenchmark end. ");
	time1 = clock() - time0;
	if (time1 == 0) {
		time1 = 2;
	}
	total = count * BENCH_LENGTH;
	rate = total * 1000 / time1;
   	printf("%d bytes/%d ms,  %d bytes/s (%d bps)\n",total,time1,rate,rate*10);

	RS_exit();
}
/*********************************************************************
 *	
 *********************************************************************
// ATtiny USART Baud Rate Register High UBBRH[11:8] 
#define UBRRH   _SFR_IO8(0x02)

// ATtiny USART Control and Status Register C UCSRC 
#define UCSRC   _SFR_IO8(0x03)

#define UMSEL   6
#define UPM1    5
#define UPM0    4
#define USBS    3
#define UCSZ1   2
#define UCSZ0   1
#define UCPOL   0

	UCSRC = (1<<USBS)|(3<<UCSZ0);     ڰь`ݒ(8ޯ,2į ޯ)

#define BAUD 9600             	// ړIUSART{[[gx 
#define MYUBRR FOSC/16/BAUD-1 	// ړIUBRRl 

 */

#define FOSC 12000000         	// MCUNbNg 

void AVR_SetBaudRate(int baud)
{
	int ucsrc = (1<<3)|(3<<1);	// UCSRC ɓl = 0x0e
	int ubrr;

//	ubrr = (FOSC / 16 / baud) - 1;	/* U2XÔƂ͂ */
	ubrr = (FOSC /  8 / baud) - 1;
	if(ubrr < 0) ubrr = 0;

	if(ubrr >= 0x1000) {
		printf("ubrr12bit܂̂600{[ȏɐݒ肵Ă\n");
	}

	UsbSetBaudRate( ubrr , ucsrc);
}

/*********************************************************************
 *	Mf[^ZbgĂ`uqƒʐM.
 *********************************************************************
 *	ʂresult_buf[8] ɓ.
 */
static int AVR_TxRx(int key_count,unsigned char *key_buffer,unsigned char *result_buf)
{
	RxBuf cmd;
	memset(&cmd,0,sizeof(RxBuf));
	memset(result_buf,0,MAX_RESULT_LENGTH);

	cmd.bmRequestType = USB_TYPE_VENDOR | USB_RECIP_DEVICE |USB_ENDPOINT_IN;
	cmd.cmd   = key_count;
	cmd.adr   = key_buffer[0]|( key_buffer[1]<<8 );
	cmd.data0 = key_buffer[2];
	cmd.data1 = key_buffer[3];
	cmd.wlength = MAX_RESULT_LENGTH;

	QueryAVR(usb_dev,&cmd,result_buf);

	return result_buf[0];
}


/*********************************************************************
 *	"COMXX:" |[g̃vpeB.
 *********************************************************************
 */
void RS_printCommInfo(char *comXX)
{
	BOOL	rc;
	HANDLE	com_handle;
	COMMPROP CommProp;

	printf("%s:",comXX);
	
	com_handle = CreateFile(
		comXX,									/* VA|[g̕ */
		GENERIC_READ | GENERIC_WRITE   ,			/* ANZX[h */
		0,
		NULL,										/* ZLeB */
		OPEN_EXISTING,								/* 쐬tO	*/
		0,											/*  */
		NULL										/* ev[g̃nh	*/
	);
	if(	comHandle == INVALID_HANDLE_VALUE) {
		printf(" Can't Open .");
	}else{
		rc = GetCommProperties(com_handle,&CommProp);
		if(rc) {
#if	0
@@DWORD dwMaxTxQueueG @@// oCgPʂ̍ő呗Mobt@TCY
@@DWORD dwMaxRxQueueG @@// oCgPʂ̍őMobt@TCY
@@DWORD dwMaxBaudG @@@ @// {[[gől
@@DWORD dwProvSubTypeG @ // voC_[^Cv
@@DWORD dwProvCapabilitiesG // T|[gꂽ֐
#endif
			printf("TxQue=%ld,RxQue=%ld,Baud=%ld"
				,CommProp.dwMaxTxQueue
				,CommProp.dwMaxRxQueue
				,CommProp.dwMaxBaud);
		}
		CloseHandle(com_handle);
	}
	printf("\n");
}
/*********************************************************************
 *	WIN32: WXgāAobɑ݂COM Port񋓂Ă݂.
 *********************************************************************
 */
void RS_printinfo(void)
{
	int   i;
	HKEY  hKey;
	char  szName[256];
	char  comXX[256];
	DWORD cbName, cbData, dwType;

	printf("==== COM Port List====\n");

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"HARDWARE\\DEVICEMAP\\SERIALCOMM",0,KEY_READ,&hKey) != ERROR_SUCCESS) {
		return;
	}
	for(i=0; /* nothing */ ;i++) {
		cbName = cbData = 256;
		if(RegEnumValue( hKey, i, szName, &cbName, NULL, &dwType, (BYTE *)comXX, &cbData ) != ERROR_SUCCESS ) {
			break;
		}
		if( dwType == REG_SZ ) {
			RS_printCommInfo(comXX);
		}
	}
	RegCloseKey(hKey);
}



/*********************************************************************
 *	
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_usbhost(char *port_no,int baudrate)
{
	int c,rcnt;
	int key_count=0;
	int key_inhibit=0;
	unsigned char tbuf[16];
	unsigned char rbuf[MAX_RESULT_LENGTH];
	static unsigned char key_buffer[16];
	if( UsbInit(0,0) == 0 ) return;	

	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	AVR_SetBaudRate(baudrate);			// AVRɓ{[[gZbg.


	printf("Entering UsbHost Mode: Escape=^%c\n", '@' +	KEY_ESCAPE_CH );

	while(1) {
		//GXP[vL[Eo.
		c = RS_keyInput();if(c == KEY_ESCAPE_CH) break;

		//MۂĂȂ΁ARS232C當󂯕t.
		if(key_inhibit == 0) {
			key_count = RS_checkdata();
			if(	key_count > 0) {
				if(key_count >=4 ) key_count = 4;
				RS_getdata(tbuf,key_count);
				memcpy( key_buffer + (4-key_count),tbuf , key_count );
			}
		}
		
		//`uqƌM.
		rcnt = AVR_TxRx(key_count,key_buffer,rbuf);	

		//`uq͂RS232CɑM.
		key_inhibit = rcnt & 0x80;					// TxBuffer FULL ?
		if(rcnt & RESULT_LENGTH_MASK) {
			RS_putdata(rbuf + 1 , rcnt & RESULT_LENGTH_MASK);	// AVR --> RS232c
		}
	}

	RS_exit();
	UsbExit();
}
/*********************************************************************
 *	
 *********************************************************************
 *	CTRL+A ŒEo.
 *
 */
void RS_terminal(char *port_no,int baudrate)
{
	int c;
	unsigned char buf[16];

	if( upfile != NULL) {
		upload_fp = fopen(upfile,"rb");
	}

	RS_init(port_no,baudrate);			// 'COMx:' I[v.
	printf("Entering TerminalMode: Escape=^%c\n", '@' +	KEY_ESCAPE_CH );
	signal(SIGINT,SIG_IGN);	// ^C 𖳌ɂ.

	while(1) {
		c = RS_keyInputUP();
		if(c) {
			if(c == KEY_ESCAPE_CH) break;	//Eo.
			RS_putc(c);
		}
		if(	RS_checkdata() ) {
			RS_getdata(buf,1);
			Term_Log(buf[0]);
			putchar(buf[0]);
		}
	}
	signal(SIGINT,SIG_DFL);
	RS_exit();
}
/*********************************************************************
 *
 *********************************************************************
 */

